skill_point = 0
score = 0

max_boost = 100
boost = max_boost
boost_gain = 0
boost_gain_part = 0
boost_part = 0

max_ammo = 100
ammo = max_ammo
ammo_gain = 0
ammo_gain_part = 0
ammo_part = 0

max_hp = 3
hp = max_hp
hp_part = 0

ammo_color = {32, 255, 32}
aspd_color = {32, 255, 32}
attack_color = {255, 192, 64}
barrage_color = {255, 255, 32}
boost_color = {32, 32, 255}
default_color = {255, 255, 255}
enemy_color = {255, 32, 32}
hp_color = {255, 32, 32}
luck_color = {255, 32, 255}
mvspd_color = {160, 160, 160}
pspd_color = {255, 128, 255}
skill_point_color = {255, 255, 32}



enemies = {'Rock', 'BigRock', 'Waver', 'Shooter', 'Seeker', 'Orbitter'}

attacks = {
    'Neutral', 
    'Double', 'Triple', 'Rapid', 'Spread', 'Spin', 'Split', 'Homing', 'Blast', 
    'Back', 'Side', 'Laser', 'Flame', 'Big', 'Explode', 'Lightning', 'Bounce',
}

attack_cooldowns = {
    ['Neutral'] = 0.24,
    ['Double'] = 0.32,
    ['Triple'] = 0.32,
    ['Rapid'] = 0.12,
    ['Spread'] = 0.16,
    ['Spin'] = 0.32,
    ['Split'] = 0.32,
    ['Homing'] = 0.56,
    ['Blast'] = 0.64,
    ['Back'] = 0.32,
    ['Side'] = 0.32,
    ['Laser'] = 0.048,
    ['Flame'] = 0.048,
    ['Big'] = 0.4,
    ['Explode'] = 0.4,
    ['Lightning'] = 0.2,
    ['Bounce'] = 0.32,
}

attack_ammo = {
    ['Neutral'] = 0,
    ['Double'] = 2,
    ['Triple'] = 3,
    ['Rapid'] = 1,
    ['Spread'] = 1,
    ['Spin'] = 2,
    ['Split'] = 3,
    ['Homing'] = 5,
    ['Blast'] = 6,
    ['Back'] = 2,
    ['Side'] = 2,
    ['Laser'] = 0.4,
    ['Flame'] = 0.4,
    ['Big'] = 4,
    ['Explode'] = 4,
    ['Lightning'] = 4,
    ['Bounce'] = 2,
}

attack_abbreviations = {
    ['Neutral'] = 'N',
    ['Double'] = '2',
    ['Triple'] = '3',
    ['Rapid'] = 'R',
    ['Spread'] = 'RS',
    ['Spin'] = 'Sp',
    ['Split'] = '2S',
    ['Homing'] = 'H',
    ['Blast'] = 'W',
    ['Back'] = 'Ba',
    ['Side'] = 'Si',
    ['Laser'] = 'La',
    ['Flame'] = 'F',
    ['Big'] = '4S',
    ['Explode'] = 'E',
    ['Lightning'] = 'Li',
    ['Bounce'] = 'Bn',
}

attack_colors = {
    ['Neutral'] = {},
    ['Double'] = {},
    ['Triple'] = {},
    ['Rapid'] = {},
    ['Spread'] = {},
    ['Spin'] = {},
    ['Split'] = {},
    ['Homing'] = {},
    ['Blast'] = {},
    ['Back'] = {},
    ['Side'] = {},
    ['Laser'] = {},
    ['Flame'] = {},
    ['Big'] = {},
    ['Explode'] = {},
    ['Lightning'] = {},
    ['Bounce'] = {},
}



function setCollisionClasses(area)
    area.world:addCollisionClass('Enemy')
    area.world:addCollisionClass('Projectile', {ignores = {'Projectile'}, enter = {'Enemy'}})
    area.world:addCollisionClass('Collectable', {ignores = {'Projectile'}})
    area.world:addCollisionClass('Player', {ignores = {'Enemy'}, enter = {'Enemy', 'Collectable'}})
    area.world:addCollisionClass('EnemyProjectile', {ignores = {'EnemyProjectile', 'Projectile'}, enter = {'Player', 'Projectile'}})
end

function createIrregularPolygon(size, point_amount)
    local point_amount = point_amount or 8
    local points = {}
    for i = 1, point_amount do
        local angle_interval = 2*math.pi/point_amount
        local s = size + math.randomp(-size/4, size/4)
        local angle = (i-1)*angle_interval + math.randomp(-angle_interval/4, angle_interval/4)
        table.insert(points, s*math.cos(angle))
        table.insert(points, s*math.sin(angle))
    end
    return points
end
