return {
description = "Outline",

new = function(self)
	self.canvas = love.graphics.newCanvas()

	self.shader = love.graphics.newShader[[
        extern vec2 textureSize;
        vec4 effect(vec4 color, Image texture, vec2 tc, vec2 pc) {
            vec4 t = Texel(texture, tc);
            float x = 1/textureSize.x;
            float y = 1/textureSize.y;

            vec4 c01 = Texel(texture, vec2(tc.x, tc.y - y));
            vec4 c10 = Texel(texture, vec2(tc.x - x, tc.y));
            vec4 c11 = Texel(texture, vec2(tc.x, tc.y));
            vec4 c12 = Texel(texture, vec2(tc.x + x, tc.y));
            vec4 c21 = Texel(texture, vec2(tc.x, tc.y + y));

            float a = ((c11.a < 0.01) && (c01.a >= 0.1 || c10.a >= 0.1 || c12.a >= 0.1 || c21.a >= 0.1)) ? 1.0 : 0.0;
            float b = t.a;
            vec3 out_color1 = ((c11.a < 0.1) && (c01.a >= 0.1)) ? c01.rgb : vec3(0.0, 0.0, 0.0);
            vec3 out_color2 = ((c11.a < 0.1) && (c10.a >= 0.1)) ? c10.rgb : vec3(0.0, 0.0, 0.0);
            vec3 out_color3 = ((c11.a < 0.1) && (c12.a >= 0.1)) ? c12.rgb : vec3(0.0, 0.0, 0.0);
            vec3 out_color4 = ((c11.a < 0.1) && (c21.a >= 0.1)) ? c21.rgb : vec3(0.0, 0.0, 0.0);
            vec3 ocf = max(out_color1, max(out_color2, max(out_color3, out_color4)));
            vec3 out_color = (a >= 1.0) ? ocf : vec3(0.0, 0.0, 0.0);
            return vec4(out_color, max(a, b));
        }
	]]
    self.shader:send('textureSize', {gw, gh})
end,

draw = function(self, func, ...)
	self:_apply_shader_to_scene(self.shader, self.canvas, func, ...)
end,

set = function(self, key, value)
	if key == "textureSize" then
		self.shader:send(key, value)
	else
		error("Unknown property: " .. tostring(key))
	end

	return self
end
}
