Object = require 'libraries/classic/classic'
Input = require 'libraries/boipushy/Input'
Grid = require 'libraries/grid/grid'
Vector = require 'libraries/hump/vector'
JumperPathfinder = require('libraries.jumper.jumper.pathfinder')
JumperGrid = require('libraries.jumper.jumper.grid')
fn = require 'libraries/moses/moses'
Timer = require 'libraries/timer/Timer'
Physics = require 'libraries/hxdx'
Lume = require 'libraries/lurker/lume'
Lurker = require 'libraries/lurker/lurker'
Camera = require 'libraries/hump/camera'
Shake = require 'libraries/hump/Shake'
Animation = require 'libraries/anal/AnAL'
Math = require 'libraries/mlib/mlib'
JSON = require 'libraries/json/json'
Serialize = require 'libraries/ser/ser'
Text = require 'libraries/popo/Text'
draft = require('libraries/draft/draft')()
Shine = require 'libraries/shine'
require 'libraries/TEsound'
require 'libraries/utils'
require 'engine'
require 'globals'
require 'enet'
GameObject = require 'GameObject'
requireAll()
startSession()

function love.load(arg)
    resize(2)
    load()
end

function love.update(dt)
    update(dt)
end

function love.draw()
    draw()
end

function love.resize(w, h)
    sx, sy = w/gw, h/gh
end

function love.quit()
    quit()
end

function love.run()
    if love.math then love.math.setRandomSeed(os.time()) end
    if love.load then love.load(arg) end
    if love.timer then love.timer.step() end

    local dt = 0
    local fixed_dt = 1/60
    local accumulator = 0

    while true do
        if love.event then
            love.event.pump()
            for name, a, b, c, d, e, f in love.event.poll() do
                if name == 'quit' then
                    if not love.quit or not love.quit() then
                        return a
                    end
                end
                love.handlers[name](a, b, c, d, e, f)
            end
        end

        if love.timer then
            love.timer.step()
            dt = love.timer.getDelta()
        end

        accumulator = accumulator + dt
        while accumulator >= fixed_dt do
            if love.update then love.update(fixed_dt) end
            accumulator = accumulator - fixed_dt
        end

        if love.graphics and love.graphics.isActive() then
            love.graphics.clear(love.graphics.getBackgroundColor())
            love.graphics.origin()
            if love.draw then love.draw() end
            love.graphics.present()
        end

        if love.timer then love.timer.sleep(0.0001) end
    end
end
