local BloodParticle = GameObject:extend()

function BloodParticle:new(area, x, y, opts)
    BloodParticle.super.new(self, area, x, y, opts)

    self.r = opts.r or 8
    self.s = math.randomp(0.33, 1)
    self.color = opts.color or {255, 255, 255}
    self.angle = math.randomp(0, 2*math.pi)
    self.v = math.randomp(50, 400)
    self.damping = math.randomp(40, 55)
    self.sd = math.randomp(40, 55)
    self.alpha = 255
    self.alphad = math.randomp(40, 55)
end

function BloodParticle:update(dt)
    BloodParticle.super.update(self, dt)
    self.x = self.x + self.v*math.cos(self.angle)*dt
    self.y = self.y + self.v*math.sin(self.angle)*dt
    self.v = self.v*self.damping*dt
    self.s = self.s*self.sd*dt
    self.alpha = self.alpha*self.alphad*dt
    if self.v <= 2 then self.dead = true end
end

function BloodParticle:draw()
    if frame % 3 == 0 then
        local r, g, b = unpack(self.color)
        love.graphics.setColor(r, g, b, self.alpha)
        love.graphics.circle('fill', self.x, self.y, self.s*self.r)
        love.graphics.setColor(255, 255, 255, 255)
    end
end

function BloodParticle:destroy()
    BloodParticle.super.destroy(self)
end

return BloodParticle
