local DeadLine = GameObject:extend()

function DeadLine:new(area, x, y, opts)
    DeadLine.super.new(self, area, x, y, opts)

    self.w, self.h = distance(self.x1, self.y1, self.x2, self.y2), 2
    if self.w <= 0 then self.w = 5 end
    self:addPhysics((self.x1+self.x2)/2, (self.y1+self.y2)/2, {collider_type = 'Rectangle', w = self.w, h = self.h})
    self.body:setFixedRotation(false)
    self.body:setLinearVelocity(self.vx/2, self.vy/2)
    self.body:applyAngularImpulse(math.randomp(-10, 10))

    self.invisible = false
    self.timer:after(math.randomp(0.6, 1.2), function()
        self.timer:everyi('invisible', 0.1, 0.005, function() self.invisible = not self.invisible end, nil, function() self.dead = true end)
    end)

    self.timer:everyi('damping', 0.2, 0.01, function() 
        local vx, vy = self.body:getLinearVelocity()
        self.body:setLinearVelocity(0.8*vx, 0.8*vy)
    end)
end

function DeadLine:update(dt)
    DeadLine.super.update(self, dt)
end

function DeadLine:draw()
    if self.invisible then return end
    love.graphics.setColor(self.color)
    pushRotate(self.x, self.y, self.body:getAngle())
    love.graphics.line(self.x - self.w/2, self.y, self.x + self.w/2, self.y)
    love.graphics.pop()
    love.graphics.setColor(255, 255, 255)
end

function DeadLine:destroy()
    DeadLine.super.destroy(self)
end

return DeadLine
