local EffectArea = GameObject:extend()

function EffectArea:new(area, x, y, opts)
    EffectArea.super.new(self, area, x, y, opts)
    self.r = math.randomp(64, 96)
    self.timer:after(4, function()
        self.timer:tween(0.25, self, {r = 0}, 'in-out-cubic', function() self.dead = true end)
    end)

    self.player_inside = false
end

function EffectArea:update(dt)
    EffectArea.super.update(self, dt)

    local d = distance(self.x, self.y, self.player.x, self.player.y)
    if d < self.r and not self.player_inside then
        self.player_inside = true
        self.player.build.aspd_boosting = true
        self.aspd_boosting_id = self.player:addBuff(nil, aspd_color)
    elseif self.player_inside and d > self.r then
        self.player_inside = false
        self.player.build.aspd_boosting = false
        self.player:removeBuff(self.aspd_boosting_id)
    end
end

function EffectArea:draw()
    love.graphics.setColor(self.color)
    love.graphics.circle('line', self.x, self.y, self.r + math.random(-2, 2))
    love.graphics.setColor(255, 255, 255)
end

function EffectArea:destroy()
    EffectArea.super.destroy(self)
end

return EffectArea
