local ExplodeParticle = GameObject:extend()

function ExplodeParticle:new(area, x, y, opts)
    ExplodeParticle.super.new(self, area, x, y, opts)

    self.color = opts.color or {255, 255, 255}
    self.r = opts.r or math.randomp(2, 3)
    self.angle = math.randomp(0, 2*math.pi)
    self.v = opts.v or math.randomp(75, 150)
    self.timer:tween(opts.d or math.randomp(0.3, 0.5), self, {r = 0, v = 0}, 'linear', function() self.dead = true end)
end

function ExplodeParticle:update(dt)
    ExplodeParticle.super.update(self, dt)
    self.x = self.x + self.v*math.cos(self.angle)*dt
    self.y = self.y + self.v*math.sin(self.angle)*dt
end

function ExplodeParticle:draw()
    love.graphics.setColor(self.color)
    love.graphics.circle('fill', self.x, self.y, self.r)
    love.graphics.setColor(255, 255, 255)
end

function ExplodeParticle:destroy()
    ExplodeParticle.super.destroy(self)
end

return ExplodeParticle
