local IrregularPolygonEffect = GameObject:extend()

function IrregularPolygonEffect:new(area, x, y, opts)
    IrregularPolygonEffect.super.new(self, area, x, y, opts)

    self.vertices = createIrregularPolygon(self.w)
    self.s = 1
    self.timer:tween(0.5, self, {s = 4}, 'in-out-cubic', function() 
        self.timer:tween(1, self, {s = 0}, 'in-out-cubic', function() self.dead = true end)
    end)
end

function IrregularPolygonEffect:update(dt)
    IrregularPolygonEffect.super.update(self, dt)
    self.x, self.y = self.parent.x, self.parent.y
end

function IrregularPolygonEffect:draw()
    pushRotateScale(self.x, self.y, 0, self.s, self.s)
    love.graphics.setColor(self.color)
    local points = fn.map(self.vertices, function(k, v) if k % 2 == 1 then return self.x + v + math.randomp(-1, 1) else return self.y + v + math.randomp(-1, 1) end end)
    love.graphics.polygon('fill', points)
    love.graphics.setColor(255, 255, 255)
    love.graphics.pop()
end

function IrregularPolygonEffect:destroy()
    IrregularPolygonEffect.super.destroy(self)
end

return IrregularPolygonEffect
