local PreAttackEffect = GameObject:extend()

function PreAttackEffect:new(area, x, y, opts)
    PreAttackEffect.super.new(self, area, x, y, opts)

    self.timer:every(0.02, function()
        self.area:addGameObject('TargettedParticle', self.x + math.randomp(-20, 20), self.y + math.randomp(-20, 20), {target_x = self.x, target_y = self.y, color = self.color})
    end)

    self.timer:after(self.duration - self.duration/4, function() self.dead = true end)
end

function PreAttackEffect:update(dt)
    PreAttackEffect.super.update(self, dt)
    if self.parent and self.parent.body then
        if self.parent.class_name == 'Seeker' then
            self.x, self.y = self.parent.x + 1.0*self.parent.w*math.cos(self.parent.body:getAngle() - math.pi), self.parent.y + 1.0*self.parent.w*math.sin(self.parent.body:getAngle() - math.pi)
        else self.x, self.y = self.parent.x + 1.4*self.parent.w*math.cos(self.parent.body:getAngle()), self.parent.y + 1.4*self.parent.w*math.sin(self.parent.body:getAngle()) end
    end
end

function PreAttackEffect:draw()

end

function PreAttackEffect:destroy()
    PreAttackEffect.super.destroy(self)
end

return PreAttackEffect
