local TargettedParticle = GameObject:extend()

function TargettedParticle:new(area, x, y, opts)
    TargettedParticle.super.new(self, area, x, y, opts)

    self.r = opts.r or math.randomp(2, 3)
    self.timer:tween(opts.d or math.randomp(0.1, 0.3), self, {r = 0, x = self.target_x, y = self.target_y}, 'out-cubic', function() self.dead = true end)
end

function TargettedParticle:update(dt)
    TargettedParticle.super.update(self, dt)
end

function TargettedParticle:draw()
    love.graphics.setColor(self.color)
    love.graphics.circle('fill', self.x, self.y, self.r)
    love.graphics.setColor(255, 255, 255)
end

function TargettedParticle:destroy()
    TargettedParticle.super.destroy(self)
end

return TargettedParticle
