local TrailParticle = GameObject:extend()

function TrailParticle:new(area, x, y, opts)
    TrailParticle.super.new(self, area, x, y, opts)

    self.r = opts.r or math.randomp(4, 6)
    self.color = opts.color or {255, 255, 255}
    self.timer:tween(opts.d or math.randomp(0.3, 0.5), self, {r = 0}, 'linear', function() self.dead = true end)
end

function TrailParticle:update(dt)
    TrailParticle.super.update(self, dt)
end

function TrailParticle:draw()
    if self.parent and self.parent.disappearing then return end
    love.graphics.setColor(self.color)
    love.graphics.circle('fill', self.x, self.y, self.r)
    love.graphics.setColor(255, 255, 255)
end

function TrailParticle:destroy()
    TrailParticle.super.destroy(self)
end

return TrailParticle
