local Weapon = GameObject:extend()

function Weapon:new(area, x, y, opts)
    Weapon.super.new(self, area, x, y, opts)

    self.w, self.h = 12, 12
    self.r = self.w
    self.x = table.random({0 - 40, gw + 40})
    self.y = math.randomp(40, gh - 40)
    self:addPhysics(self.x, self.y, {collider_type = 'Circle', r = self.r, collision_class = 'Collectable'})
    self.body:setPosition(self.x, self.y)
    self.body:applyLinearImpulse(-math.sign(self.x)*10, 0)
end

function Weapon:update(dt)
    Weapon.super.update(self, dt)
end

function Weapon:draw()
    love.graphics.circle('line', self.x, self.y, self.r)
end

function Weapon:destroy()
    Weapon.super.destroy(self)
end

function Weapon:die()
    self.dead = true
end

return Weapon
